VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "msflxgrd.ocx"
Begin VB.Form Form1 
   Caption         =   "Books"
   ClientHeight    =   3600
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6975
   LinkTopic       =   "Form1"
   ScaleHeight     =   3600
   ScaleWidth      =   6975
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdPreview 
      Caption         =   "Preview"
      Default         =   -1  'True
      Height          =   375
      Left            =   2160
      TabIndex        =   2
      Top             =   2040
      Width           =   735
   End
   Begin VB.CommandButton cmdPrint 
      Caption         =   "Print"
      Height          =   375
      Left            =   3000
      TabIndex        =   1
      Top             =   2040
      Width           =   735
   End
   Begin MSFlexGridLib.MSFlexGrid flxData 
      Height          =   1695
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2175
      _ExtentX        =   3836
      _ExtentY        =   2990
      _Version        =   393216
      AllowUserResizing=   1
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Truncate the string so it fits within the width.
Private Function BoundedText(ByVal ptr As Object, ByVal txt As String, ByVal max_wid As Single) As String
    Do While ptr.TextWidth(txt) > max_wid
        txt = Left$(txt, Len(txt) - 1)
    Loop
    BoundedText = txt
End Function
Private Sub PrintFlexGrid(ByVal ptr As Object, ByVal flx As MSFlexGrid, ByVal xmin As Single, ByVal ymin As Single)
Const GAP = 60

Dim xmax As Single
Dim ymax As Single
Dim X As Single
Dim c As Integer
Dim r As Integer

    With ptr.Font
        .Name = flxData.Font.Name
        .Size = flxData.Font.Size
    End With

    With flxData
        ' See how wide the whole thing is.
        xmax = xmin + GAP
        For c = 0 To .Cols - 1
            xmax = xmax + .ColWidth(c) + 2 * GAP
        Next c

        ' Print each row.
        ptr.CurrentY = ymin
        For r = 0 To .Rows - 1
            ' Draw a line above this row.
            If r > 0 Then ptr.Line (xmin, ptr.CurrentY)-(xmax, ptr.CurrentY)
            ptr.CurrentY = ptr.CurrentY + GAP

            ' Print the entries on this row.
            X = xmin + GAP
            For c = 0 To .Cols - 1
                ptr.CurrentX = X
                ptr.Print BoundedText(ptr, .TextMatrix(r, c), .ColWidth(c));
                X = X + .ColWidth(c) + 2 * GAP
            Next c
            ptr.CurrentY = ptr.CurrentY + GAP

            ' Move to the next line.
            ptr.Print
        Next r
        ymax = ptr.CurrentY

        ' Draw a box around everything.
        ptr.Line (xmin, ymin)-(xmax, ymax), , B

        ' Draw lines between the columns.
        X = xmin
        For c = 0 To .Cols - 2
            X = X + .ColWidth(c) + 2 * GAP
            ptr.Line (X, ymin)-(X, ymax)
        Next c
    End With
End Sub

Private Sub cmdPreview_Click()
    Form2.AutoRedraw = True
    PrintFlexGrid Form2, flxData, 500, 500
    Form2.Show
End Sub

Private Sub cmdPrint_Click()
    PrintFlexGrid Printer, flxData, 1440, 1440
    Printer.EndDoc
End Sub


Private Sub Form_Load()
Dim db_file As String
Dim statement As String
Dim conn As ADODB.Connection
Dim rs As ADODB.Recordset
Dim c As Integer
Dim r As Integer
Dim txt As String
Dim col_wid() As Single
Dim field_wid As Single

    ' Prepare the grid.
    With flxData
        ' Use a font that is likely to be on the printer.
        .Font.Name = "Times New Roman"
        .Font.Size = 10

        .Rows = 2
        .FixedRows = 1
        .FixedCols = 0
        .Rows = 1
        .Cols = 2
        .SelectionMode = flexSelectionByRow
        .TextMatrix(0, 0) = "Books I Need"
    End With

    ' Get the data.
    db_file = App.Path
    If Right$(db_file, 1) <> "\" Then db_file = db_file & "\"
    db_file = db_file & "books.mdb"

    ' Open a connection.
    Set conn = New ADODB.Connection
    conn.ConnectionString = _
        "Provider=Microsoft.Jet.OLEDB.4.0;" & _
        "Data Source=" & db_file & ";" & _
        "Persist Security Info=False"
    conn.Open

    ' Select the data.
    statement = "SELECT * FROM Books ORDER BY Title"

    ' Get the records.
    Set rs = conn.Execute(statement, , adCmdText)

    ' Display the values for each row.
    ReDim col_wid(0 To rs.Fields.Count - 1)
    With flxData
        col_wid(0) = TextWidth(.TextMatrix(0, 0))

        Font.Name = flxData.Font.Name
        Font.Size = flxData.Font.Size

        r = 1
        Do While Not rs.EOF
            .Rows = .Rows + 1
            For c = 0 To rs.Fields.Count - 1
                txt = rs.Fields(c)
                .TextMatrix(r, c) = txt
                If col_wid(c) < TextWidth(txt) Then col_wid(c) = TextWidth(txt)
            Next c

            rs.MoveNext
            r = r + 1
        Loop

        ' Size the columns.
        For c = 0 To UBound(col_wid)
            .ColWidth(c) = col_wid(c) + 120
        Next c
    End With

    ' Close the recordset and connection.
    rs.Close
    conn.Close
End Sub
Private Sub Form_Resize()
Dim hgt As Single
Dim X As Single

    hgt = ScaleHeight - 120 - cmdPrint.Height
    If hgt < 120 Then hgt = 120

    flxData.Move 0, 0, ScaleWidth, hgt

    X = ScaleWidth / 2 - cmdPreview.Width - 60
    cmdPreview.Move X, flxData.Top + flxData.Height + 60

    X = ScaleWidth / 2 + 60
    cmdPrint.Move X, cmdPreview.Top
End Sub
